function [L,u,v] = rgb2lab(image);
% convert RGB image to CIE-Lab
% one may use the following to read the image from jpg file:
% [image,Map] = imread('image.jpg','jpg');

image = double(image) / double(max(max(max(image))));

M = [0.412453  0.357580  0.189423; ...
     0.212671  0.715160  0.072169; ...
     0.019334  0.119193  0.950227];
white = M*[1 1 1]';

npix = prod(size(image(:,:,1)));
rgb = reshape(image,npix,3)';
XYZ = M*rgb;

ratioY = XYZ(2,:) / white(2);
L = 116 * (ratioY .^ (1/3)) - 16;

tmp = XYZ(1,:) + 15*XYZ(2,:) + 3*XYZ(3,:);
u = 13 * L .* (4*XYZ(1,:)./tmp - 0.2009);
v = 13 * L .* (9*XYZ(2,:)./tmp - 0.4610);

L = reshape(L,size(image(:,:,1)));
u = reshape(u,size(image(:,:,1)));
v = reshape(v,size(image(:,:,1)));
