#include <stdio.h>
#include <stdlib.h>
#include "s2m.h"
#include "debug.h"


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void check_select_leaf(int num_it) 
{
  int  select_leaf();
  int *frequency;
  int i, leaf;

  frequency = (int *)malloc(NE*sizeof(int));
  if (!frequency) error("allocation error");
  for (i=0; i<NE; i++)
    frequency[i]=0;

  for (i=0; i<num_it; i++) {
    leaf = select_leaf();
    frequency[leaf]++;
  }

  for (i=0; i<NE; i++)
    printf("%d ", frequency[i]);
  printf("\n");
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void check_exclude_leaf() 
{
  void exclude_leaf(int leaf);
  int l;

  print_tree();
  while (1) {
    fprintf(stderr,"enter leaf to exclude (-1 to quit): ");
    fscanf(stdin,"%d", &l);
    if (l== -1) 
      return;

    exclude_leaf(l);
    print_tree();
  }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void check_find_crossing() 
{
  struct xrs *find_crossing(int u1, int u2);
  struct xrs *xedge;
  int i, k,l;

  print_reps2l();
  printf("\n");
  while (1) {
    fprintf(stderr,"enter 2 names to merge (-1 to quit): ");
    fscanf(stdin,"%d %d", &k, &l);
    if (k== -1)
      return;
    if (Pname[k] != k || Pname[l] != l)
      error("these are not valid names");

    fprintf(stderr,"\nmerging %d %d...\n",k,l);
    xedge = find_crossing(k,l);

    print_reps2l();  
    print_xleaves(xedge); 
    printf("Pname = [");
    for (i=0; i<NP; i++)
      printf("%d ", Pname[i]);
    printf("]\n");
  }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void print_xleaves(struct xrs *xedge)
{
  struct xrs *px;

  printf("\ncrossing leaves:\n");
  px = xedge;
  while (px != NULL) {
    printf("%d ", px->leaf);
    px = px->next;
  }
  printf("\n\n");
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void print_reps2l()
{
  int u;
  struct vcross *p;
  struct xrs *pl;

  for (u=0; u<NP; u++) {
    printf("[%d] **%d v's**  ", u, numv[u]);

    p = Urep[u];
    while (p != NULL) {
      printf(" ([%d], ", p->vn);
      pl = p->leaves;
      while (pl != NULL) {
	printf("%d ", pl->leaf);
	pl = pl->next;
      }
      printf(")");
      p = p->next;
    }

    printf("\n");
  }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void print_tree()
{
  int i, k, l;

  k = NE;
  if (k%2)
    k++;
  for (l=NL-1; l>0; l--) {
    for(i=0; i<k; i++)
      printf("%ld ", ETree[l][i]);
    printf("\n");

    k >>= 1;
    if (k%2)
      k++;
  }
  printf("%ld\n\n", ETree[0][0]);
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
