#include <stdio.h>
#include <stdlib.h>
#include "s2m.h"

static unsigned long **_ETree;
static struct edge *_leaf2ij;
static struct vcross **_Urep;
static struct vcross  *_Vrep;
static struct xrs *_UVleaves;
static int *_numv;
static int *_Pname;
static int *_Psize;
static int _total_vcross;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void store_global()
{
  int k,l;

  _total_vcross = total_vcross;

  _leaf2ij = (struct edge *)malloc((NE+NE%2)*sizeof(struct edge));
  if (!_leaf2ij) error("allocation error");
  memcpy(_leaf2ij, leaf2ij, (NE+NE%2)*sizeof(struct edge));

  _Urep = (struct vcross **)malloc(NP*sizeof(struct vcross *));
  if (!_Urep) error("allocation error");
  memcpy(_Urep, Urep, NP*sizeof(struct vcross *));

  _Vrep = (struct vcross *)malloc(NE*sizeof(struct vcross));
  if (!_Vrep) error("allocation error");
  memcpy(_Vrep, Vrep, NE*sizeof(struct vcross));

  _UVleaves = (struct xrs *)malloc(NE*sizeof(struct xrs));
  if (!_UVleaves) error("allocation error");
  memcpy(_UVleaves, UVleaves, NE*sizeof(struct xrs));

  _numv = (int *)malloc(NP*sizeof(int));
  if (!_numv) error("allocation error");
  memcpy(_numv, numv, NP*sizeof(int));

  _Pname = (int *)malloc(NP*sizeof(int));
  if (!_Pname) error("allocation error");
  memcpy(_Pname, Pname, NP*sizeof(int));

  _Psize = (int *)malloc(NP*sizeof(int));
  if (!_Psize) error("allocation error");
  memcpy(_Psize, Psize, NP*sizeof(int));


  /* tree copy */
  _ETree = (unsigned long **)malloc(NL*sizeof(unsigned long *));
  if (!_ETree) error("allocation error");

  l = NL;
  k = NE;
  while (k>1) {
    l--;
    if (k%2)
      k++;

    _ETree[l] = (unsigned long *)malloc(k*sizeof(unsigned long));
    if (!_ETree[l]) error("allocation error");
    memcpy(_ETree[l], ETree[l], k*sizeof(unsigned long));

    k >>= 1;
  }
  _ETree[0] = (unsigned long *)malloc(sizeof(unsigned long));
  if (!_ETree[0]) error("allocation error");
  _ETree[0][0] = ETree[0][0];
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void restore_global()
{
  int k,l;

  total_vcross = _total_vcross ;

  memcpy(leaf2ij, _leaf2ij, (NE+NE%2)*sizeof(struct edge));
  memcpy(Urep, _Urep, NP*sizeof(struct vcross *));
  memcpy(Vrep, _Vrep, NE*sizeof(struct vcross));
  memcpy(UVleaves, _UVleaves, NE*sizeof(struct xrs));
  memcpy(numv, _numv, NP*sizeof(int));
  memcpy(Pname, _Pname, NP*sizeof(int));
  memcpy(Psize, _Psize, NP*sizeof(int));

  /* tree copy */
  l = NL;
  k = NE;
  while (k>1) {
    l--;
    if (k%2)
      k++;
    memcpy(ETree[l], _ETree[l], k*sizeof(unsigned long));
    k >>= 1;
  }
  ETree[0][0] = _ETree[0][0];
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
