#define NBINS 11

/* ----------------------- types ------------------------------------ */
struct edge {
  int u;
  int v;
};

struct xrs {
  int leaf;
  struct xrs *next;
};

struct vcross {
  int vn;
  struct xrs *leaves;
  struct xrs *tail;
  struct vcross *next;
};

struct histype {
  short top;
  float avr[NBINS];
  unsigned short num[NBINS];
  short order[NBINS];
};

/* ----------------------- functions ---------------------------------*/
void histog_init(struct histype *hist, float data);
void histog_insert(struct histype *hist, float data);
void minsum(struct histype *hist, int *first, int *second);
float histog_median(struct histype *hist, int total, int correction);
struct histype **histog_alloc();
void histog_print(struct histype *hist);

void error(char *message);


/* ----------------------- shared variables --------------------------*/
extern unsigned long **ETree;
extern struct edge *leaf2ij;
extern struct vcross **Urep;
extern struct vcross  *Vrep;
extern struct xrs *UVleaves;
extern int *numv;
extern int *Pname;
extern int *Psize;
extern int total_vcross;
extern int NP; /* number of nodes */
extern int NE; /* number of edges */
extern int NL; /* depth of edge tree */
